'use strict'

var fs = require('fs')
var normaliseOptions = require('./js/normaliseOptions')
var validate = require('./js/validate')

function readFileGo(file, options) {

  validate(file)
  file = file.trim()
  options = normaliseOptions(options)

  var contents

  try {
    contents = fs.readFileSync(file, {encoding: options.encoding, flag: options.flag})
  } catch (e) {

    if (e.code === 'ENOENT') {

      var message = (options.message) ? options.message + ' ' + file : e.message

      if (options.throw) {
        e.message = message
        throw e
      }

      if (!options.silent) {
        options.logFunc(message)
      }

    } else {
      throw e
    }
  }
  return contents
}

module.exports = readFileGo
